#ifndef ARBIOSTRING_HH
#define ARBIOSTRING_HH

#include "Arbre.hh"
#include <string>

// Lectura d'un arbre binari d'enters, acci.  Els elements 
// s'introdueixen en preordre: primer l'arrel, desprs el subarbre
// esquerre i per ltim el subarbre dret. Els arbres buits es
// representen amb la marca.

/* Exemple: l'arbre 

     1
   /   \
  2     3

   es llegeix 1 2 0 0 3 0 0 (o amb els numeros en distintes lnies) */


void lee(Arbre<string>& a, string marca);
/* Pre: a es buit; el canal estandar d'entrada cont el recorregut en preordre
   d'un arbre binari A d'enters marcat amb "marca" */  
/* Post: a = A */



// Escriptura d'un arbre binari d'enteros, acci.  Els elements 
// s'escriuen en preordre: primer l'arrel, desprs el subarbre 
// esquerre, i per ltim el subarbre dret.   

/* Exemple: l'arbre 

     1
   /   \
  2     3

   s'escriu 1 2 0 0 3 0 0 */

void esc(Arbre<string> &a);
/* Pre: cert */ 
/* Post: El canal estandar de sortida cont el recorregut en preordre d'a */ 

#endif
